//+------------------------------------------------------------------+
//|                                     Indepth Ichimoku Scoring.mq4 |
//|                                                           Jas Wu |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property description "Indepth Ichimoku Scoring"
#property description "Indicator Made By Jas Wu"
#property copyright "Jas Wu"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_level1 0
#property indicator_level2 0
//--- input parameters
input int      TenKan=8; // Tenkan Sen Period
input int      Kijun = 15; //Kijun Period
input int   Senkou = 26; //Senkou Span B
input double FilterLevel = 1.0; //Filter Fixed Level

double Scoring[], Down[], StdvUp[], StdvDn[], MA[];
int barstocursor=0;
string UprDown = " ";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
 ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,true);
 IndicatorShortName("Indepth Ichimoku Scoring");
 IndicatorBuffers(1);
   
   SetIndexStyle(0,DRAW_LINE, STYLE_SOLID, 3, clrSpringGreen); 
   SetIndexBuffer(0,Scoring);
   SetIndexLabel(0, "Scoring");
   
   SetLevelStyle(STYLE_DOT, 1, clrCrimson);
   SetLevelValue(0, FilterLevel);
   SetLevelValue(1, -FilterLevel);
      
   ObjectCreate("Ichi", OBJ_LABEL, ChartWindowFind(0, "Indepth Ichimoku Scoring"), 0, 0, 0, 0);
   ObjectSetText("Ichi", "ggggg", 20, "Webdings", clrBlack);   
   ObjectSet("Ichi", OBJPROP_CORNER, 0);
   ObjectSet("Ichi", OBJPROP_XDISTANCE, 5);
   ObjectSet("Ichi", OBJPROP_YDISTANCE, 20);
   ObjectSet("Ichi", OBJPROP_BACK, false);      
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int pos;
 int limit=Bars-10;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 pos=limit;
 
      for(int t=0; t<=limit; t++)
      {
         Scoring[t] = 0; double UpOffset = 1.0; double DnOffset = 1.0;
         
         double TenkenSen = iIchimoku(_Symbol, _Period, TenKan, Kijun, Senkou, MODE_TENKANSEN, t);
         double KijunSen = iIchimoku(_Symbol, _Period, TenKan, Kijun, Senkou, MODE_KIJUNSEN, t);  
         double Chikou = iIchimoku(_Symbol, _Period, TenKan, Kijun, Senkou, MODE_CHIKOUSPAN, t+Kijun);   
         double SpanA = iIchimoku(_Symbol, _Period, TenKan, Kijun, Senkou, MODE_SENKOUSPANA, t); //Buy Kumo    
         double SpanB = iIchimoku(_Symbol, _Period, TenKan, Kijun, Senkou, MODE_SENKOUSPANB, t); //Sell Kumo 
         if(SpanA > SpanB && Close[t] < SpanB) UpOffset = 0.5; 
         if(SpanA < SpanB && Close[t] > SpanB) DnOffset = 0.5;                                  
         if(SpanA > SpanB) Scoring[t] += 1*UpOffset; if(SpanA < SpanB) Scoring[t] -= 1*DnOffset;
         if(TenkenSen > KijunSen) Scoring[t] += 1*UpOffset; if(TenkenSen < KijunSen) Scoring[t] -= 1*DnOffset; 
         if(Close[t] > Chikou) Scoring[t] += 1*UpOffset; if(Close[t] < Chikou) Scoring[t] -= 1*DnOffset; 
         if(Close[t] > TenkenSen) Scoring[t] += 1*UpOffset; if(Close[t] < TenkenSen) Scoring[t] -= 1*DnOffset;
         if(Close[t] > KijunSen) Scoring[t] += 1*UpOffset; if(Close[t] < KijunSen) Scoring[t] -= 1*DnOffset;
         if(Close[t] < SpanA && Close[t] > SpanB) Scoring[t] += 1*UpOffset; if(Close[t] > SpanA && Close[t] < SpanB) Scoring[t] -= 1*DnOffset;
      } 

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+


void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{

      if(id==CHARTEVENT_MOUSE_MOVE) 
        { 
         //--- Prepare variables 
         int      x     =(int)lparam; 
         int      y     =(int)dparam; 
         datetime dt    =0; 
         double   price =0; 
         int      window=0; 
         
         //--- Convert the X and Y coordinates in terms of date/time 
         if(ChartXYToTimePrice(0,x,y,window,dt,price)) 
           { 
               barstocursor=Bars(NULL, 0, dt, iTime(NULL, 0, 0))-1;
            
                  //--- Tell Direction Text
                  if(Scoring[barstocursor] > FilterLevel) UprDown = "UpTrend";
                  if(Scoring[barstocursor] < -FilterLevel) UprDown = "DownTrend";  
                  if(Scoring[barstocursor] < FilterLevel && Scoring[barstocursor] > -FilterLevel) UprDown = "No Trend";  
               
                  //--- Create Text 
                  ObjectCreate("ICHI1", OBJ_LABEL, ChartWindowFind(0, "Indepth Ichimoku Scoring"), 0, 0, 0, 0);
                  if(Scoring[barstocursor] > FilterLevel) ObjectSetText("ICHI1", UprDown, 14, "Arial", Lime);   
                  if(Scoring[barstocursor] < -FilterLevel) ObjectSetText("ICHI1", UprDown, 14, "Arial", Crimson);   
                  if(Scoring[barstocursor] <= FilterLevel && Scoring[barstocursor] >= -FilterLevel) ObjectSetText("ICHI1", UprDown, 14, "Arial", Gray);                            
                  ObjectSet("ICHI1", OBJPROP_CORNER, 0);
                  ObjectSet("ICHI1", OBJPROP_XDISTANCE, 15);
                  ObjectSet("ICHI1", OBJPROP_YDISTANCE, 20);
                  ObjectSet("ICHI1", OBJPROP_BACK, false);               
            
           }     
        }
     
}
         